/* upstart
 *
 * Copyright © 2008 Canonical Ltd.
 * Author: Scott James Remnant <scott@netsplit.com>.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301 USA
 */

#include <utmp.h>

#include <nih/macros.h>
#include <nih/string.h>

/**
 * prev_level:
 *
 * return the previous runlevel
 **/
char *
prev_level (void)
{
	struct utmp utmp, *lvl;
	char prev[2];
	char *retval;

	prev[0] = prev[1] = '\0';

	memset (&utmp, 0, sizeof (utmp));
	utmp.ut_type = RUN_LVL;

	setutent ();
	lvl = getutid (&utmp);
	if (lvl) {
		prev[0] = lvl->ut_pid % 256;
	}
	endutent ();

	if (! prev[0])
		prev[0] = 'N';

	NIH_MUST (retval = nih_strdup (NULL, prev));

	return retval;
}
